
IMTalkBox = function(node){

    var self = this;
    this.newMessageTimeout = 0;

    this.node = node;

    this.isOpened = false;
    this.isActive = false;
    this.isOffline = false;
    this.isLoaded = false;
    this.isLogLoaded = false;
    this.unreadMessages = 0;

    var cont = $("#main_tab_contact_proto").clone();

    cont.attr('id', 'main_tab_contact_'+this.node);

    $('#main_im_tab_container').parent().after(cont);

    this.main_tab_contact = $('#main_tab_contact_'+this.node);
    this.$cont = $('div.talkbox', this.main_tab_contact );
    this.$cont.click(function(e){
        if(!$(e.target).is('div.min_cmd', self.$cont))
        {
            self.activate();
        }
    });

    $('div.min_cmd', this.$cont).click(
        function(){
            self.hide();
        });

    $('div.close_cmd', this.$cont).click(
        function(){
            self.hideTab();
        });

    this.talkbox_username = $('div.talkbox_username', this.$cont);
    this.talkbox_msg = $('input.talkbox_msg', this.$cont);

    $('#main_tab_contact_'+this.node+' .fake_node a.main_tab_contact_click').click(
        function(){
            self.toggle();
            self.annul();
            $('#contacts_widget').hide();
        });

    this.box = $('div.box', this.$cont);
    this.$input = $('input[name=msg]', this.$cont);
    this.$input.keydown( function(e){

        if(e.keyCode != 13)
            return;

        if ( $.trim(self.$input.val()) == '')
            return;

        var message = self.$input.val();
        self.$input.val('');
        //$('#message_preloader', self.$cont).show();
        self.box.attr('scrollTop', self.box.attr('scrollHeight'));

        var data = {
            'to': self.node,
            'message': message
        };

        im_bindInProcess = true;

        $.ajax({
            'type': 'POST',
            'url': window.logMsgUrl,
            'data': data,
            'success': function(data){


                //                $('#message_preloader', self.$cont).hide();
                self.writeTimeDelimiter();
                self.write(data);

                im_bindInProcess = false;
            },
            'error': function(){
                im_bindInProcess = false;
                log('logmsg error occured');
            },
            'complete': function(){
                im_bindInProcess = false;
            },
            'dataType': 'json'
        });

    });

    $.post(updateUserInfoUrl, {
        username: this.node,
        action: 'open',
        from: 'tabConstruct'
    }, function(data){

        if ( typeof data != 'undefined')
        {
            contactManager.contacts[self.node] = data;
            $('a.main_tab_contact_click', self.main_tab_contact).removeClass('ow_preloader');
            $('a.main_tab_contact_click', self.main_tab_contact).addClass('ow_ic_chat');
            self.main_tab_contact.addClass('ow_mild_green');
            $('.im_main_tab_text', cont).html(data['username']);

            $('img.talk_box_avatar', self.$cont).attr('src', contactManager.contacts[self.node].user_avatar_src);
            $('img.talk_box_avatar', self.$cont).attr('alt', contactManager.contacts[self.node].username);
            $('img.talk_box_avatar', self.$cont).attr('title', contactManager.contacts[self.node].username);

            $('a', self.talkbox_username).html('<b>'+contactManager.contacts[self.node].username+'</b>' );
            $('a', self.talkbox_username).attr('href', contactManager.contacts[self.node].user_url);
            $('#talkbox_contact_info .ow_avatar a', self.$cont).attr('href', contactManager.contacts[self.node].user_url);
            $('#talkbox_contact_info .ow_avatar a', self.$cont).attr('target', '_blank');

            self.align();
            OW.trigger(self.node+'_isLoaded');
            self.isLoaded = true;

        }
        else
        {
            $('.im_main_tab_text', cont).html(self.node);
        }
    }, 'json');

    this.align = function()
    {
        var padding_left = self.main_tab_contact.css( 'padding-left' );
        if (typeof padding_left == 'undefined')
        {
            padding_left = 0;
        }
        else
        {
            padding_left = parseInt(padding_left.substring(0, 1));
        }
        var margin_left = self.main_tab_contact.css( 'margin-left' );
        if (typeof margin_left == 'undefined')
        {
            margin_left = 0;
        }
        else
        {
            margin_left = parseInt(margin_left.substring(0, 1));
        }
        var padding_right = self.main_tab_contact.css( 'padding-right' );
        if (typeof padding_right == 'undefined')
        {
            padding_right = 0;
        }
        else
        {
            padding_right = parseInt( padding_right.substring(0, 1) );
        }
        var margin_right = self.main_tab_contact.css( 'margin-right' );
        if (typeof margin_right == 'undefined')
        {
            margin_right = 0;
        }
        else
        {
            margin_right = parseInt( margin_right.substring(0, 1) );
        }
        self.left = parseInt(( self.main_tab_contact.width() + padding_left + margin_left + padding_right + margin_right )/2 - 50);
        self.top = self.main_tab_contact.height();
        self.$cont.css({
            'left': self.left+'px',
            'top': self.top+'px'
        });

    }

    this.annul = function(){

        if (typeof contactManager.contacts[this.node] != 'undefined')
        {
            this.unreadMessages = 0;
            $('.im_main_tab_text', this.main_tab_contact).html( contactManager.contacts[this.node].username );
        }

        self.align();

        if ( self.newMessageTimeout !== 0 )
        {
            clearInterval( self.newMessageTimeout );
            document.title = oldTitle;
            self.newMessageTimeout = 0;
        }
    }

    this.activate = function(){
        activeContact = this.node;
        this.isActive = true;
        this.isOpened = true;

        this.$cont.css('z-index', '99');
        $('#contacts_widget').hide();

        if (typeof contactManager.contacts[self.node] == 'undefined')
        {
            return;
        }

        contactManager.contacts[self.node].is_active = true;
        contactManager.contacts[self.node].is_opened = true;

        return self;
    }

    this.hide = function(){
        this.$cont.hide();
        self.isActive = false;
        activeContact = '';

        if (typeof contactManager.contacts[self.node] == 'undefined')
        {
            return;
        }
        contactManager.contacts[self.node].is_active = false;

        $.post(updateUserInfoUrl, {
            username: self.node,
            action: 'min',
            from: 'min_cmd'
        }, function(data){

            }, 'json');

        return self;
    }

    this.hideTab = function(){
        self.$cont.hide();
        self.main_tab_contact.hide();

        if (typeof contactManager.contacts[self.node] == 'undefined')
        {
            return;
        }

        $.post(updateUserInfoUrl, {
            username: this.node,
            action: 'close',
            /*            closeTab: con.resource,*/
            from: 'hideTab'
        }, function(data){
            self.isActive = false;
            contactManager.contacts[self.node].is_active = false;
            self.isOpened = false;
            contactManager.contacts[self.node].is_opened = false;

            self.$cont.remove();
            self.main_tab_contact.remove();
            delete windows[self.node];

        }, 'json');

    }

    this.isVisible = function(){
        return this.$cont.css('display') == 'block';
    }

    this.notifyOnNewMessage = function(){

        this.unreadMessages++;

        $('.im_main_tab_text', '#main_tab_contact_'+this.node).html( contactManager.contacts[this.node].username + ' ('+this.unreadMessages+')' );

        var msg = $("#new_message_label").html();

        if ( self.newMessageTimeout === 0  )
        {
            self.newMessageTimeout = setInterval(function() {
                document.title = document.title == msg ? oldTitle : msg;
            }, 1000);
        }
        return self;
    }

    this.setOnline = function(){
        if (this.isOffline)
        {
            this.isOffline = false;
            if ( contactManager.contacts[this.node].is_friend )
            {
                $('.talk_box_status', this.$cont).css( 'display', 'none' );
                $('b',this.talkbox_username).removeClass('ow_remark');

                this.updateStatus( $('#user_online_message').html().replace("[username]", contactManager.contacts[this.node].username) );
            }
        //this.main_tab_contact.addClass('ow_mild_green');
        }
        return self;
    }

    this.setOffline = function(){
        if (!this.isOffline)
        {
            this.isOffline = true;
            if ( contactManager.contacts[this.node].is_friend )
            {
                $('.talk_box_status', this.$cont).css( 'display', 'block' );
                $('b', this.talkbox_username).addClass('ow_remark');
                this.updateStatus($('#user_offline_message').html().replace("[username]", contactManager.contacts[this.node].username));
            //this.main_tab_contact.removeClass('ow_mild_green');
            }
        }

        return self;
    }

    this.onShow = function(){
        talkBoxManager.deactivateAll(self.node);
        self.activate();
        self.$cont.show();

        self.box = $('div.box', self.$cont);
        self.box.attr('scrollTop', self.box.attr('scrollHeight'));
        self.talkbox_msg.focus();

        if (typeof contactManager.contacts[self.node] == 'undefined')
        {
            return;
        }

        $.post(updateUserInfoUrl, {
            username: self.node,
            action: 'open',
            option: 'activate',
            from: 'show'
        }, function(){}, 'json');
    }

    this.show = function(){
        if (self.isOpened)
        {
            self.onShow();
        }
        else
        {
            OW.bind(self.node+'_tabOpened', function(){
                self.onShow();
                OW.unbind(self.node+'_tabOpened');
            });
        }

        return self;
    }

    this.onShowTab = function(omit_last_message){
        self.align();

        self.isOpened = true;
        contactManager.contacts[self.node].is_opened = true;
        OW.trigger(self.node+'_tabOpened');
        log(self.node+'_tabOpened', 1);

        if(ajaxim_getLogInProcess[self.node])
        {
            log('ajaxim_getLogInProcess['+self.node+']', 1);
        }

        if ( !this.isLogLoaded && !ajaxim_getLogInProcess[self.node] )
        {
            ajaxim_getLogInProcess[self.node] = true;
            $.ajax({
                url: getLogUrl,
                type: 'POST',
                data: {
                    username: this.node,
                    lastMessageTimestamp: contactManager.contacts[self.node].last_message_timestamp,
                    omit_last_message: omit_last_message
                },
                success: function(data){
                    $('#message_preloader', self.$cont).remove();
                    if ( data.length > 0 )
                    {
                        var lastMessageTimeString = '';
                        $(data).each(function(){
                            self.write(this, 'ow_remark');
                            lastMessageTimeString = this.read;
                        });

                        self.writeTimeDelimiter($('#last_message_sent_label').html()+' '+lastMessageTimeString);
                        date = new Date();
                        contactManager.updateLastMessageTimestamp(self.node, parseInt(date / 1000));
                    }

                    OW.trigger(self.node+'_isLogLoaded');
                    self.isLogLoaded = true;

                    ajaxim_getLogInProcess[self.node] = false;

                },
                error: function(){
                    log('getLog error occured');
                    ajaxim_getLogInProcess[self.node] = false;
                },
                complete: function(){
                    ajaxim_getLogInProcess[self.node] = false;
                },
                dataType: 'json'
            });
        }
    }

    this.showTab = function(omit_last_message){

        if (typeof omit_last_message == 'undefined')
            omit_last_message = 0;

        self.main_tab_contact.show();

        if ( this.isLoaded )
        {
            self.onShowTab(omit_last_message);
        }
        else
        {
            OW.bind(self.node+'_isLoaded', function(){

                self.onShowTab(omit_last_message);

                OW.unbind(self.node+'_isLoaded');
            });
        }
        return this;
    }

    this.toggle = function(){
        if(!this.isVisible())
        {
            return self.show();
        }
        else
        {
            return self.hide();
        }
    }

    this.write = function(msg, css_class){

        var message_container = $('#talk_box_msg_proto').clone();

        message_container.removeAttr('id');
        message_container.removeAttr('style');

        if( msg.from == my.node ){
            $('.message_cap', message_container).html("<img src='"+my.avatar+"' alt='"+my.realname+"' title='"+my.realname+"' />");
        }
        else{
            $('.message_cap', message_container).html("<img src='"+contactManager.contacts[this.node].user_avatar_src+"' alt='"+contactManager.contacts[this.node].username+"' title='"+contactManager.contacts[this.node].username+"' />");

        }

        if ( typeof msg != 'undefined' && typeof msg.message != 'undefined' )
        {
            $('.message', message_container).html( msg.message.replace(/&lt;/g,'<').replace(/&gt;/g,'>').replace(/&amp;/g,'&').replace(/&quot;/g,'"') );
        }


        if (typeof css_class != 'undefined')
        {
            $('.message', message_container).addClass(css_class);
        }

        $('#message_list', this.box).append(message_container);

        //this.box.append(message_container);
        //this.lastMessageTimestamp = msg.timestamp;
        contactManager.updateLastMessageTimestamp(this.node, parseInt(msg.timestamp));

        this.box.attr('scrollTop', this.box.attr('scrollHeight'));

        return self;
    }

    this.writeTimeDelimiter = function(message){

        if ( contactManager.contacts[this.node].last_message_timestamp == 0 )
        {
            return self;
        }
        var notification_container = $('#talk_box_msg_proto').clone();

        notification_container.removeAttr('id');
        notification_container.removeAttr('style');

        if (typeof message == 'undefined')
        {
            currentDate = new Date();
            currentDate = currentDate.getTime() / 1000;
            if ( currentDate - contactManager.contacts[self.node].last_message_timestamp > 300 ) // TODO Set 300 sec
            {
                time = new Date(contactManager.contacts[self.node].last_message_timestamp*1000);
                minutes = time.getMinutes();
                if ( time.getMinutes() < 10 )
                {
                    minutes = '0'+time.getMinutes();
                }
                message=time.getHours()+':'+minutes; //  TODO remove getSeconds()
            }
            else
                return self;
        }

        $('.message', notification_container).addClass('ow_tiny ow_remark ow_center');
        $('.message', notification_container).html(message);

        //this.box.append(notification_container);
        $('#message_list', this.box).append(notification_container);
        this.box.attr('scrollTop', this.box.attr('scrollHeight'));

        return self
    }

    this.updateStatus = function(status){

        var notification_container = $('#talk_box_msg_proto').clone();

        notification_container.removeAttr('id');
        notification_container.removeAttr('style');

        $('.message', notification_container).addClass('ow_tiny ow_remark ow_center');
        $('.message', notification_container).html(status);

        $('#message_list', this.box).append(notification_container);
        //this.box.append(notification_container);

        this.box.attr('scrollTop', this.box.attr('scrollHeight'));
    }
}

TalkBoxManager = function(){
    windows = {};

    this.get = function(node){
        if( typeof windows[node] == 'undefined' ){

            windows[node] = new IMTalkBox(node);
        }

        return windows[node];
    }

    this.deactivateAll = function(node){

        for(var key in windows)
        {
            if ( node != key && windows[key].isActive )
            {
                windows[key].hide();
            }
        }
    }
}


ContactManager = function(){
    var self = this;

    this.count = 0;
    this.count_others = 0;
    //this.contacts = [];
    this.contacts = {};
    //    this.contact_info = [];
    this.timestamps = {};

    this.contacts_widget = $('#contacts_widget');

    $('#main_im_tab').click( function(){
        /*if ( typeof im_bindConnection != 'undefined' )
        {
            bind();
        }*/
        self.toggleRoster();
    } )

    this.connect = function(){
        $('#main_im_tab').removeClass('ow_preloader');
        $('#main_im_tab').addClass('ow_ic_chat');
    }

    this.disconnect = function(){
        $('#main_im_tab').removeClass('ow_ic_chat');
        $('#main_im_tab').addClass('ow_preloader');
    }

    this.add = function(node){
        if ( typeof this.contacts[node.node] == 'undefined' )
        {
            this.contacts[node.node] = node;
        }

        if ( (node.node != my.node) && $('#contact_'+node.node).length == 0 )
        {
            this.addRoster(node);
        }
    }

    this.addRoster = function(node){

        var contacts_item = $('#contact_proto').clone();
        contacts_item.attr('id', 'contact_'+node.node);
        contacts_item.removeAttr('style');

        $('#main_im_tab').qtip('disable');
        $('#main_im_tab').qtip('hide');

        if ( node['is_active'] )
        {
            node['is_opened'] = true;
        }
        else
        {
            node['is_opened'] = false;
        }

        $( '.contact_username', contacts_item ).attr('title', node['username']);
        $( '.contact_avatar img', contacts_item ).attr('src', node['user_avatar_src']);
        $( '.contact_username', contacts_item ).html(node['username']);

        if ( node['is_friend'] )
        {
            self.count++;
            $('#contacts_friends').find( '#contacts_friends_list' ).append( contacts_item );
            $('#contacts_friends_label').css('display', 'block');

            if ( self.count_others > 0 )
            {
                $('#contacts_other_label').css('display', 'block');
            }
        }
        else
        {
            self.count_others++;

            if ( self.count > 0 )
            {
                $('#contacts_friends_label').css('display', 'block');
                $('#contacts_other_label').css('display', 'block');
            }

            $('#contacts_other').css('display', 'block');

            $('#contacts_other').find( '#contacts_other_list' ).append( contacts_item );

        }

        $('span', '#main_im_tab').html( $('#main_tab_label_proto').html()+' ('+contactManager.getCount()+')');

        if ( $.inArray(node.node, active_list)>=0 )
        {
            var box = talkBoxManager.get(node.node);
            box.showTab();
            if (activeContact == node.node)
            {
                box.show();
            }
        }

        if ( typeof windows[node.node] != 'undefined' && windows[node.node].isLoaded )
        {
            talkBoxManager.get(node.node).setOnline();
        }

        $('#contact_'+node.node).click(
            function(){
                var box = talkBoxManager.get(node.node);
                box.showTab();
                box.show();
                self.contacts_widget.hide();
            });

    }

    this.deleteRoster = function(node){

        if( typeof this.contacts[node] == 'undefined')
            return;

        if ( $('#contact_'+node).length != 0 )
        {
            if ( contactManager.contacts[node]['is_friend'] )
            {
                this.count--;
                if ( this.count == 0 )
                {
                    $('#contacts_friends_label').css('display', 'none');
                    $('#contacts_other_label').css('display', 'none');
                }
            }
            else
            {
                this.count_others--;
                if ( this.count_others == 0 )
                {
                    $('#contacts_other').css('display', 'none');
                }
            }

            $('#contact_'+node).remove();
            //windows[node].setOffline();
            if ( typeof windows[node] != "undefined" )
            {
                windows[node].setOffline();
            }
        /*else
            {
                delete self.contacts[node];
            }*/
        }

        if( this.getCount() == 0 ){
            this.toggleRoster();
            $('span', '#main_im_tab').html($('#main_tab_label_proto').html());
        }
        else
        {
            $('span', '#main_im_tab').html($('#main_tab_label_proto').html()+' ('+this.getCount()+')');
        }

    }

    this.toggleRoster = function(){
        if ( this.getCount() != 0 )
        {
            $(window).bind( 'click.im_contacts_widget',
                function(e){
                    if(!$(e.target).is('#contacts_widget *, #main_im_tab *, #contacts_widget, #main_im_tab'))
                    {
                        self.contacts_widget.hide();
                    }

                });
            this.contacts_widget.css('left',  ($('.main_im_tab_container').width() - this.contacts_widget.width()) / 2 + 8  );
            this.contacts_widget.toggle();
        }
        else
        {
            $(document).unbind( 'click.im_contacts_widget');
            $('#main_im_tab').qtip('enable');

            this.contacts_widget.hide();
        }
    }

    this.getContacts = function(){
        return this.contacts;
    }

    this.get = function(node){

        if ( typeof this.contacts[node] == 'undefined' )
            return false;

        return this.contacts[node];
    }

    this.getCount = function(){
        return this.count+this.count_others;
    }

    this.getLastMessageTimestamps = function(){

        $.each(this.contacts, function(){
            self.timestamps[this.node] = parseInt(this.last_message_timestamp);
        });

        return self.timestamps;
    }

    this.updateLastMessageTimestamp = function( node, timestamp )
    {
        this.contacts[node].last_message_timestamp = timestamp;
    }
}
