
$(function(){

    var im_console = document.getElementById('im_console');
    var main_im_tab = document.getElementById('main_im_tab');

    if ( typeof im_console == 'undefined' || im_console == null || typeof main_im_tab == 'undefined' || main_im_tab == null )
        return;

    $('#main_im_tab').parent().attr('id', 'main_im_tab_container');
//    main_im_tab.parentNode.setAttribute('id', 'main_im_tab_container');
    main_im_tab.parentNode.appendChild(im_console.parentNode.removeChild(im_console));

    ajaxim_bindInProcess = false;
    ajaxim_onlineNowClickInProcess = [];
    ajaxim_getLogInProcess = [];

    setInterval(bind, ajaxim_ping);

    OW.bind('base.online_now_click',
        function(username){
            if (ajaxim_onlineNowClickInProcess[username])
            {
                log('double click', 1);
                return;
            }
            if (username != my.username)
            {
                ajaxim_onlineNowClickInProcess[username] = true;
                $.ajax({
                    url: updateUserInfoUrl,
                    type: 'POST',
                    data: {
                        username: username,
                        click: 'online_now_click'
                    },
                    success: function(data){

                        if ( typeof data != 'undefined')
                        {
                            if ( typeof data['error'] != 'undefined')
                            {
                                OW.warning(data['error']);
                                ajaxim_onlineNowClickInProcess[username] = false;
                                return;
                            }
                            box = talkBoxManager.get(data['node']);

                            box.showTab();
                            OW.bind(data['node']+'_tabOpened', function(){

                                box.show();
                                OW.unbind(data['node']+'_tabOpened');
                            });
                        }

                        ajaxim_onlineNowClickInProcess[username] = false;
                    },
                    error: function(){
                        log('onlinenow click error occured');
                        ajaxim_onlineNowClickInProcess[username] = false;
                    },
                    complete: function(){
                        ajaxim_onlineNowClickInProcess[username] = false;
                    },
                    dataType: 'json'
                });
            }
        });

    $('#main_im_tab').attr('title', $("#no_online_users").html() );
    $('#main_im_tab').qtip({
        position: {
            corner: {
                target: 'bottomMiddle',
                tooltip: 'topMiddle'
            },
            adjust:{
                x:0,
                y:10
            }
        },
        style:{
            width:{
                max: 350
            },
            textAlign: 'center',
            border: {
                radius: 5,
                color: '#666666'
            },
            tip: 'topMiddle',
            name: 'dark',
            background:'#666666',
            padding: 0,
            fontSize:11
        },
        show:{
            delay:1
        },
        content:{
            prerender: true
        }
    });

    contactManager = new ContactManager();
    talkBoxManager = new TalkBoxManager();

});


function bind()
{
    if (!ajaxim_bindInProcess)
    {
        timestamps = contactManager.getLastMessageTimestamps();
        var str = '';
        $.each(timestamps, function(key, time){
            str += '<p>'+key+":"+time+'</p>';
        });

        log(str);

        data = {
            action: 'get',
            lastMessageTimestamps: timestamps
        };

        ajaxim_bindInProcess = true;
        $.ajax({
            url: bindUrl,
            type: 'POST',
            data: data,
            success: function(data){

                if (typeof data.presenceList != 'undefined' && data.presenceList.length > 0)
                {
                    $.each(data.presenceList, function(){

                        if ( this.type == 'offline' )
                        {
                            contactManager.deleteRoster( this.node );
                        }

                        if ( this.type == 'online' )
                        {
                            contactManager.add( this );
                        }

                    } );
                }

                if (data.messageListLength > 0)
                {
                    $.each(data.messageList, function(){
                        handleMessage( this );
                    } );
                }

                ajaxim_bindInProcess = false;
            },
            error: function(){
                log('bind error occured');
                ajaxim_bindInProcess = false;
            },
            complete: function()
            {
                ajaxim_bindInProcess = false;
            },
            dataType: 'json'
        });
    }
}

function handleMessage(new_message) {

    if( typeof new_message.message != 'undefined' ){
        var box;
        // Message to my other resources
        if( new_message.from == my.node ){
            if ( new_message.timestamp == contactManager.contacts[new_message.to].last_message_timestamp )
            {
                return;
            }

            box = talkBoxManager.get(new_message.to);

            if ( !box.isOpened )
            {
                box.showTab(1);

                OW.bind(new_message.to+'_tabOpened', function(){

                    OW.bind(new_message.to+'_isLogLoaded', function(){

                        log(new_message.to+'_isLogLoaded', 1);
                        box.show();
                        box.writeTimeDelimiter();
                        //new_message.message += '_isLogLoaded';
                        box.write(new_message);

                        OW.unbind(new_message.to+'_isLogLoaded');
                    });

                    OW.unbind(new_message.to+'_tabOpened');
                });

            }
            else
            {
                if (!box.isActive)
                {
                    log('!box.isActive', 1);
                    box.show();
                }
                box.writeTimeDelimiter();
                //new_message.message += 'box.isActive';
                box.write(new_message);
            }



        }
        else{
            // Message to other contact
            if ( new_message.timestamp == contactManager.contacts[new_message.from].last_message_timestamp )
            {
                return;
            }



            box = talkBoxManager.get(new_message.from);
            if( !box.isOpened )
            {
                box.showTab(1);

                OW.bind(new_message.from+'_tabOpened', function(){

                    OW.bind(new_message.from+'_isLogLoaded', function(){

                        log(new_message.from+'_isLogLoaded', 1);

                        box.write(new_message).setOnline().notifyOnNewMessage()

                        OW.unbind(new_message.from+'_isLogLoaded');
                    });

                    OW.unbind(new_message.from+'_tabOpened');
                });

            }
            else
            {
                box.writeTimeDelimiter();
                box.write(new_message);

                if (!box.isActive)
                {
                    log('!box.isActive', 1);
                    box.notifyOnNewMessage();
                }
            }
        }
    }

}

/* DEBUG MODE */
//log = function(message){};
function log(message, append){
    /*
    if (append)
    {
        $("#server_msg_container2").append('<p>'+message+'</p>');
    }
    else
    {
        $("#server_msg_container").html('<p>'+message+'</p>');
    } */
}
